{% extends "base.html" %}
{% block title %}Deploy log{% endblock %}
{% block content %}
  <div class="outer-div">
    <div class="mx-auto">
      <h1 id="deploy-heading"></h1>
      <p>Status: <strong>{{ status }}</strong></p>
      <div class="bg-dark text-white p-5">
        <p id="deploy-log">{{ log |safe }}</p>
      </div>
    </div>
  </div>
  <script>
    // Get app id from the current URL
    const appId = window.location.href.split('/').at(-2);

    $('#deploy-heading').text(`Deployment log for ${appId}`);

    // Connect with the consumer in Django
    var ws_scheme = window.location.protocol == "https:" ? "wss" : "ws";
    const deploySocket = new WebSocket(
      `${ws_scheme}://${window.location.host}/ws/deploy/${appId}`
    );

    // Receive and render a new ouput everytime there is a change in the log file
    const deployLog = document.querySelector('#deploy-log');

    deploySocket.onmessage = e => {
      $('#deploy-log').empty();
      $('.ansi2html-content').remove();
      const data = JSON.parse(e.data);
      deployLog.innerHTML = (data.content + '\n');
    };

    // Return an error if the socket is closed unexpectedly
    deploySocket.onclose = e => {
      console.error('Deploy socket is closed');
    };

    // Closing the WebSocket before closing the browser
    window.onbeforeunload = () => {
      deploySocket.close();
    }
  </script>
{% endblock %}